/* classic Rexx version, ---rgf, 2003-02 */
/* this version works on Java 1.1 too (because using "wrapEnumeration()") */

      /* load the BSF4Rexx functions and start a JVM, if necessary */
if rxFuncQuery("BSF") = 1 then   /* BSF() support not loaded yet ? */
do
   call rxFuncAdd "BsfLoadFuncs", "BSF4Rexx", "BsfLoadFuncs"
   call BsfLoadFuncs
   call BsfLoadJava
end
   /* 'Class.class' is pre-registered for Rexx, cf. docs */
system=bsf('invoke', 'Class.class', 'forName', 'string', 'java.lang.System')

properties=bsf('invoke', system, "getProperties")  /* get the System properties  */

enum=bsf('invoke', properties, 'propertyNames')    /* get an enumeration of the property names */

enum=bsf('wrapEnumeration', enum)
/* wrap the Enumeration object, so Java 1.1 can handle this too */
say copies("=", 70)

do while bsf('invoke', enum, 'hasMoreElements') /* loop over enumeration   */
   key=bsf('invoke', enum, 'nextElement')       /* get next element        */
   say "key:" left("["key"]", 30) "value: ["||bsf('invoke', properties, 'getProperty', 'String', key)"]"
end

